; check if map collision data decompressed
; $80/A262 BF 00 00 82 LDA $820000,x[$82:8AD6] A:8000 X:8AD6 Y:8000 D:1D00 DB:82 S:1FE1 P:eNvmxdIzC
; $80/A266 C9 FF FF    CMP #$FFFF              A:FFFF X:8AD6 Y:8000 D:1D00 DB:82 S:1FE1 P:eNvmxdIzC
; $80/A269 D0 21       BNE $21    [$A28C]      A:FFFF X:8AD6 Y:8000 D:1D00 DB:82 S:1FE1 P:envmxdIZC
; $80/A26B E2 21       SEP #$21                A:FFFF X:8AD6 Y:8000 D:1D00 DB:82 S:1FE1 P:envmxdIZC
; $80/A26D 60          RTS                     A:FFFF X:8AD6 Y:8000 D:1D00 DB:82 S:1FE1 P:envMxdIZC

; check if graphical map layout (32x32 blocks) decompressed
; $80/9E7B BF 00 00 82 LDA $820000,x[$82:89A0] A:FF80 X:89A0 Y:FFFE D:1D00 DB:82 S:1FE2 P:eNvMxdIzc
; $80/9E7F A8          TAY                     A:FFFF X:89A0 Y:FFFE D:1D00 DB:82 S:1FE2 P:eNvMxdIzc
; $80/9E80 C0 FF FF    CPY #$FFFF              A:FFFF X:89A0 Y:FFFF D:1D00 DB:82 S:1FE2 P:eNvMxdIzc
; $80/9E83 F0 17       BEQ $17    [$9E9C]      A:FFFF X:89A0 Y:FFFF D:1D00 DB:82 S:1FE2 P:envMxdIZC
; $80/9E9C 4C B9 9D    JMP $9DB9  [$80:9DB9]   A:FFFF X:89A0 Y:FFFF D:1D00 DB:82 S:1FE2 P:envMxdIZC


;================================================================================

; hijack original code
org $809E7B
	jsl      check_map_decompressed
	
;================================================================================

org $829100  ; freespace


check_map_decompressed:
	php
	rep      #$30
	lda.l    $820000,x
	pha
	
	; check if finished decompressing map data
	cpx.w    #$89A0  ; file offset $8289A0 is the end-flag
	bne      .exit
	
	; check stage ID and room ID
	lda.w    $0078
	cmp.w    #$0006  ; stage 7
	bne      .exit
	lda.w    $007A
	cmp.w    #$0008  ; sub-area (final boss room)
	bne      .exit
	jsr      edit_map_layout
	
.exit:
	pla
	plp
	rtl

;================================================================================

edit_map_layout:
	phx
	phy
	
    ; load blocks
	ldx.w    #block_data
	ldy.w    #$4A10
	jsr      load_map_data

    ; load collision mask
	ldx.w    #collsion_data
	ldy.w    #$7A10
	jsr      load_map_data
	
	; cleanup and return
	ply
	plx
	rts
	
;================================================================================

load_map_data:
	lda.w    #$0003   ; loop counter
	sta.b    $02      ; $7E1D02

.loop:	
	lda.w    #$000F   ; copy $10 bytes
	mvn      $7F,$82
	tya
	clc
	adc.w    #$0070   ; next line of blocks
	tay
	dec.b    $02
	bne      .loop
	rts

;================================================================================

; edit graphical map layout (32x32 blocks)
block_data:
	db $17, $16, $00, $00, $00, $1E, $00, $00, $00, $1E, $00, $00, $00, $00, $2A, $2A  ; $7F4A10
	db $20, $18, $00, $19, $00, $23, $00, $20, $00, $23, $00, $19, $00, $00, $29, $00  ; $7F4A90
	db $22, $1A, $2B, $25, $2B, $25, $2B, $22, $2B, $25, $2B, $25, $2B, $2B, $1A, $2B  ; $7F4B10


; add collision to pits (left to right)
collsion_data:
	db $04, $1F, $00, $00, $00, $20, $00, $00, $00, $20, $00, $00, $00, $00, $00, $05  ; $7F7A10
	db $20, $01, $00, $1F, $00, $01, $00, $20, $00, $01, $00, $1F, $00, $00, $1F, $05  ; $7F7A90
	db $04, $01, $1F, $01, $1F, $01, $1F, $01, $1F, $01, $1F, $01, $1F, $1F, $21, $1F  ; $7F7B10